% atom_codes for backwards compatibility of character code lists "..."

type(text).
:- dynamic silent/0.

output_settings(_) :-
    silent,
    !.				% red  
output_settings(X) :-
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
force_output(X) :-
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
output(_) :-
    silent,
    !.				% red
output(X) :-
    (pending_step 		% for backtracking
     -> retract(pending_step),
	step(_)
     ;  true),
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
output_error(_) :-
    silent,
    !.				% red    
output_error(X) :-
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
output_strong(_) :-
    silent,
    !.				% red
output_strong(X) :-
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
output(_,_) :-
    silent,
    !.				% red
output(X,_) :-
    catch(atom_codes(Y,X),_,(Y=X)),
    format('~w~n',[Y]).
printSuccess(_) :-
    silent,
    !.				% red
printSuccess(S) :-
    format('% ~w~n',[S]).
print_spellout(X,S) :- 
    type(text),
    !,				% red
    output("Spell-out:"),
    spellout(X,S),
    newC(_).
% stages: 
%  (1) extract frontier of parse
%  (2) apply head -> morpheme rules
%  (3) affix-hop
%  (4) apply head -> morpheme rules 2
%  (5) spell
spellout(X,P) :- 
    type(text),
    !,				% red
    matrixC(X,Xp),
    frontier(Xp,_Occ,L,[]),
    prettify_list(L,Lp),
    format(string(Out1),'~w (frontier)',[Lp]),
    output(Out1),
    spellout_heads(L,M),		
    prettify_list(M,Mp),
    format(string(Out2),'=> ~w (after morpheme realization)',[Mp]),
    output(Out2),
    affix_hop(M,N,[]),		
    prettify_list(N,Np),
    format(string(Out3),'=> ~w (after affix-hop)',[Np]),
    output(Out3),
    spellout2_heads(N,O),
    prettify_list(O,Op),
    format(string(Out4),'=> ~w (morpheme realization, stage 2)',[Op]),
    output(Out4),
    spell(O,P),			
    format(string(Out5),'=> ~w',[P]),
    output(Out5).
draw_tree(_).
backtrackstep(_).
set_deriv(_).
output_link.
start_encoder.
finish_encoder.


